package asw.asw810.client.connector;

import asw.asw810.service.Service;
import asw.asw810.server.Servant;
import asw.util.logging.AswLogger;

import java.util.logging.Logger;

/* Factory per il servizio Service. */ 
public class ServiceFactory {
	
	/* logger */ 
	private Logger logger = AswLogger.getInstance().getLogger("asw.asw810.client.connector"); 

    /* il singleton per la factory */ 
	private static ServiceFactory instance = null;  
    
	/* il riferimento al servizio */
	private Service service = null; 

	/* Costruttore della factory (privato per singleton). */ 
	private ServiceFactory() {
		logger.info("Creazione della ServiceFactory"); 
	}
	
    public static synchronized ServiceFactory getInstance() { 
        if (instance==null) { 
        	instance = new ServiceFactory(); 
        }
        return instance; 
    }

    /* Factory method per il servizio Service. */ 
    public synchronized Service getService() {
		logger.info("ServiceFactory: getService()");
    	if (service==null) {
    		service = new Servant(); 
    	}
        return service; 
    }
    
}

