package asw.asw810.client.connector;

import asw.asw810.service.Service;
import asw.util.logging.AswLogger;

import java.net.*;    // per le socket 
import java.util.logging.Logger;

/* remote proxy lato client per il servizio */ 
public class ServiceClientProxy implements Service {
    private InetAddress address;    // indirizzo del server 
    private int port;                           // porta per il servizio 

	/* logger */ 
	private Logger logger = AswLogger.getInstance().getLogger("asw.asw810.client.connector"); 

	public ServiceClientProxy(InetAddress address, int port) {
		logger.info("ServiceClientProxy: Created a new Remote Proxy for Service " + address.toString() + ":" + port);
        this.address = address;    this.port = port; 
    }

    /* questo  proprio il metodo invocato dal client 
     * (anche se il client pensa di parlare direttamente con il servant) */ 
    public String alpha(String arg) { 
    	String reply = null; 
        try {
            /* crea un datagramma che codifica la richiesta di servizio 
             * ed i relativi parametri */ 
            /* la richiesta ha la forma "operazione#parametro" */
        	String request = "alpha#" + arg; 
            byte[] requestMessage = request.getBytes(); 
            DatagramPacket requestPacket = 
                 new DatagramPacket(requestMessage, 
                                    requestMessage.length, 
                                    this.address, this.port); 
             /* invia il datagramma di richiesta */ 
             DatagramSocket socket = new DatagramSocket(); 
     		logger.info("Client Proxy: calling alpha(" + arg + ")"); 
     		logger.info("Client Proxy: sending message: " + request); 
             socket.send(requestPacket);    // non bloccante 
             /* ricevi il datagramma di risposta */ 
             byte[] buffer = new byte[1000]; 
             DatagramPacket replyPacket = 
                 new DatagramPacket(buffer, buffer.length);
             socket.receive(replyPacket);    // bloccante 
             /* estrai la risposta dal datagramma di risposta */ 
             /* la risposta ha la forma "risposta" */
             reply = new String( replyPacket.getData(), 
            		 			 replyPacket.getOffset(), 
            		 			 replyPacket.getLength() ); 
      		logger.info("Client Proxy: received message: " + reply); 
     		logger.info("Client Proxy: alpha(" + arg + ") ==> " + reply);
     		socket.close();
        } catch(Exception e) {
        	e.printStackTrace(); 
        }
        return reply; 
    } 
}

